<?php

/**
 * mo_viaebay__feed_categories
 * 
 * loads and handles synced categories from via
 * 
 * @version   $Id: mo_viaebay__feed_categories.php 139 2012-12-10 16:51:05Z $
 */

/**
 * loads and handles synced categories from via
 * 
 * @package   mo_viaebay
 * @extend mo_viaebay__feed 
 */
class mo_viaebay__feed_categories extends mo_viaebay__feed
{

  /**
   * store relations
   * 
   * @var array 
   */
  protected $relations = array(
      'ChildCatalogs' => array('doSimplify'     => true),
      'ParentCatalogs' => array('doSimplify' => true),
      'Products'   => array('doSimplify' => false),
  );

  /**
   * load synced categories from via ebay
   * 
   * @extend load
   * @param array $ids
   * @return array 
   */
  public function load($ids = array(), $options = array())
  {
    $this->data = array();
    $categories = mo_viaebay__main::getInstance()->getInterface()->getCategories($ids);
    $categories = $this->buildCollection($categories);

    //set IDs as index
    foreach ($categories as $category)
    {
      unset($category['__metadata']);
      $category = $this->handleEmptyRelations($category);
      $category = $this->simplifyRelations($category);
      $this->data[$category['Id']] = $category;
    }
    return $this->data;
  }

  /**
   * returns child categories of submitted parent-category if exists
   * 
   * @param string $parentId
   * @return array 
   */
  public function getChildCategories($parentId)
  {
    if (!$data = $this->getRecord($parentId))
    {
      return array();
    }
    return $data['ChildCatalogs'];
  }

  /**
   * returns parent categories of submitted child-category if exists
   * 
   * @param string $childCategoryId
   * @return array 
   */
  public function getParentAssignments($childCategoryId)
  {
    if (!$data = $this->getRecord($childCategoryId))
    {
      return array();
    }
    return $data['ParentCatalogs'];
  }

}