<?php

/**
 * mo_viaebay__feed_orders
 * 
 * loads and handles orders from via
 * 
 * @version   $Id: mo_viaebay__feed_orders.php 139 2012-12-10 16:51:05Z $
 */

/**
 * loads and handles orders from via
 * 
 * @package   mo_viaebay
 * @extend mo_viaebay__feed 
 */
class mo_viaebay__feed_orders extends mo_viaebay__feed
{

  /**
   * stores relations
   * 
   * @var array 
   */
  protected $relations = array(
      'Address' => array('doSimplify'      => false),
      'ShippingAddress' => array('doSimplify' => false),
      'Buyer'      => array('doSimplify'      => false),
      'SalesOrderItems' => array('doSimplify' => false),
  );

  /**
   * loads and handles orders from via
   * 
   * @extend load
   * @param array $ids
   * @return array 
   */
  public function load($ids = array(), $options = array())
  {
    $orders = mo_viaebay__main::getInstance()->getInterface()->getOrders($ids);
    $orders = $this->buildCollection($orders);

    //relations
    foreach ($orders as $order)
    {
      unset($order['__metadata']);
      $order = $this->handleEmptyRelations($order);
      $order = $this->simplifyRelations($order);
      $this->data[$order['Id']] = $order;
    }

    return $this->data;
  }

}