<?php

/**
 * mo_viaebay__cron_control
 * 
 * cron control
 * 
 * @version   $Id: mo_viaebay__cron_control.php 139 2012-12-10 16:51:05Z $
 */

/**
 * cron control
 * 
 * @package   mo_viaebay 
 */
class mo_viaebay__cron_control
{

  /**
   * store filename
   *
   * @var string 
   */
  protected $filename;

  /**
   * indicates if cron control is running
   *
   * @var boolean 
   */
  public $is_running = false;

  /**
   * constructor
   *
   * @param string $suffix 
   */
  function __construct($suffix)
  {
    $directory = getShopBasePath() . 'tmp/';
    $this->filename = $directory . basename($_SERVER['PHP_SELF']) . $suffix . '.pid';

    if (is_writable($this->filename) || is_writable($directory))
    {
      $this->handleFile();
    }
    else
    {
      die("Cannot write to pid file '$this->filename'. Program execution halted.\n");
    }

    if (!$this->is_running)
    {
      $pid = getmypid();
      file_put_contents($this->filename, $pid);
    }
  }

  /**
   * destructor 
   */
  public function __destruct()
  {
    if (!$this->is_running && file_exists($this->filename) && is_writeable($this->filename))
    {
      unlink($this->filename);
    }
  }

  /**
   * handle file 
   */
  protected function handleFile()
  {
    if (file_exists($this->filename))
    {
      $pid = (int) trim(file_get_contents($this->filename));

      //mo: maybe add filedate-check prevent perm pid-hijack...
      if (posix_kill($pid, 0))
      {
        $this->is_running = true;
      }
    }
  }

}
