<?php

/**
 * mo_viaebay__helper
 * 
 * helper class 
 * 
 * @version   $Id: mo_viaebay__helper.php 139 2012-12-10 16:51:05Z $
 */

/**
 * helper class 
 * 
 * @package   mo_viaebay 
 */
class mo_viaebay__helper
{

  /**
   * convert via date to standard datae
   *
   * @param string $value
   * @param string $format
   * @return string 
   */
  public function convertViaDateToStandard($value, $format = 'Y-m-d H:i:s')
  {
    if (!preg_match('#^/Date\(([0-9]+)\)/$#', $value, $matches))
    {
      return $value;
    }

    //micro to standard
    $timestamp = substr($matches[1], 0, 10);
    return date($format, $timestamp);
  }

  /**
   * convert standard date to via date
   *
   * @param mixed $date
   * @return string 
   */
  public function convertStandardDateToVia($date)
  {
    //convert to timestamp
    if (!is_numeric($date))
    {
      $date = strtotime($date);
    }

    return 'Date(' . $date . ')';
  }

  public function convertCharset($in, $out, $params)
  {
    foreach ($params as $key => $value)
    {
      if (is_array($value))
      {
        $params[$key] = $this->convertCharset($in, $out, $value);
      }
      elseif(is_string($value))
      {
        $params[$key] = iconv($in, $out . '//TRANSLIT', $value);
      }
    }
    return $params;
  }
  
    public function resetArticleSyncDates()
    {
        $oxConfig = oxRegistry::getConfig();
        $oxDb = oxDb::getDb();
        $sql = "UPDATE mo_viaebay__articles2via 
                SET
                MO_VIAEBAY__LAST_SYNC = 0,
                MO_VIAEBAY__LAST_MPSYNC = 0
                WHERE
                OXSHOPID = " . $oxDb->quote($oxConfig->getShopId());
        $oxDb->execute($sql);
    }
}