<?php

/**
 * mo_viaebay__task_manager
 * 
 * via eBay task manager 
 * 
 * @version   $Id: mo_viaebay__task_manager.php 139 2012-12-10 16:51:05Z $
 */

/**
 * via eBay task manager 
 * 
 * @package   mo_viaebay 
 */
class mo_viaebay__task_manager
{

  /**
   * constructor
   *
   * @param array $viaConfig 
   */
  public function __construct($viaConfig)
  {
    $this->viaConfig = $viaConfig;
  }

  /**
   * mark task as finished
   *
   * @param string $task 
   */
  public function markTaskAsFinished($task)
  {
    $this->viaConfig['tasks'][$task]['last_execution'] = time();
    mo_viaebay__main::getInstance()->setViaebayConfig($this->viaConfig);
    mo_viaebay__main::getInstance()->saveViaConfig();
  }

  /**
   * check if task should be executed now
   *
   * @param string $task
   * @return mixed 
   */
  public function isTaskToBeExecuted($task)
  {
    if (empty($this->viaConfig['tasks'][$task]['interval']))
    {
      return false;
    }

    if (empty($this->viaConfig['tasks'][$task]['last_execution']))
    {
      return true;
    }

    $lastExecution = $this->viaConfig['tasks'][$task]['last_execution'];

    return $lastExecution < (time() - $this->viaConfig['tasks'][$task]['interval'] * 60);
  }
  
    public function getExecutionTimeFromTask($task) 
    {
        if (empty($this->viaConfig['tasks'][$task]['last_execution'])) {
            return false;
        }
        
        return $this->viaConfig['tasks'][$task]['last_execution'];
    }

}