<?php

/**
 * mo_viaebay__sync_manager
 * 
 * abstract sync manager
 * 
 * @version   $Id: mo_viaebay__sync_manager.php 220 2013-06-06 14:06:26Z $
 */

/**
 * abstract sync manager
 * 
 * @package   mo_viaebay
 * @abstract  
 */
abstract class mo_viaebay__sync_manager
{

  /**
   * store active instance of mo_viaebay__sync_manager
   *
   * @staticvar mo_viaebay__sync_manager 
   */
  static protected $instance = null;

  /**
   * store active feed
   *
   * @var mo_viaebay__feed 
   */
  protected $feed = null;

  /**
   * store active paramBuilder
   *
   * @var mo_viaebay__paramBuilder
   */
  protected $paramBuilder = null;

  /**
   * active logger
   *
   * @var mo_viaebay__logger
   */
  protected $logger = null;

  /**
   * active helper
   *
   * @var mo_viaebay__helper
   */
  protected $helper = null;

  /**
   * sync object
   *
   * @var object 
   */
  protected $syncObject = null;

  /**
   * sync object id
   *
   * @var string 
   */
  protected $syncObjectViaId = null;

  /**
   * sync objects ids
   *
   * @var array 
   */
  protected $syncedObjectIds = array();

  /**
   * true if object needs update
   *
   * @var boolean 
   */
  protected $currentObjectNeedsUpdate = false;

  /**
   * set sync object
   *
   * @param oxBase $object 
   */
  public function syncObject(oxBase $object)
  {
      $message = 'Processing object with Id ' . $object->getId();
      
      if ($object instanceof oxarticle) {
         $message .= "\nArtikel: " . $object->oxarticles__oxtitle->value . " (" . $object->oxarticles__oxartnum->value . ")";
      } elseif($object instanceof oxcategory) {
         $message .= "\nKategorie: " . $object->oxcategories__oxtitle->value;
      }
      
    $this->logger->info($message);
    $this->syncObject = $object;
    $this->currentObjectNeedsUpdate = false;
  }

  /**
   * constructor
   *
   * @param mo_viaebay__feed $feed
   * @param mo_viaebay__param_builder $paramBuilder
   * @param mo_viaebay__logger $logger
   * @param mo_viaebay__helper $helper 
   * @param array $viaConfig 
   * @param oxConfig $oxConfig
   */
  public function __construct(
  mo_viaebay__feed $feed, mo_viaebay__param_builder $paramBuilder, mo_viaebay__logger $logger, mo_viaebay__helper $helper, $viaConfig, $oxConfig)
  {
    $this->feed = $feed;
    $this->paramBuilder = $paramBuilder;
    $this->logger = $logger;
    $this->helper = $helper;
    $this->viaConfig = $viaConfig;
    $this->oxConfig = $oxConfig;
  }
  
    /**
     * set pricegroup if set
     * @return type
     */
    protected function setPriceGroup()
    {
        if (!$this->viaConfig['price_group']) {
           return; 
        }
        
        if (!$oxUser = $this->oxConfig->getUser()) {
            $oxUser = oxNew('oxUser');
        }
        
        $oxUser->mo_viaebay__addUserGroup('oxidprice' . $this->viaConfig['price_group']);
        $this->oxConfig->setUser($oxUser);
    }

}