<?php

/**
 * mo_viaebay__sync_manager_inventory
 * 
 * manage simple article sync with via
 * 
 * @version   $Id: mo_viaebay__sync_manager_inventory.php 219 2014-11-28 13:07:53Z $
 */

/**
 * manage simple article sync with via
 * 
 * @package   mo_viaebay
 * @extend mo_viaebay__sync_manager 
 */
class mo_viaebay__sync_manager_inventory extends mo_viaebay__sync_manager
{

    /**
     * sync article
     * 
     * @param oxBase $article 
     */
    public function syncObject(oxBase $article)
    {
        $this->setPriceGroup();

        if (!$article->oxarticles__mo_viaebay__via_id->value) {
            return true;
        }
        //Update LastMPSync always 
        $this->updateLastMPSync($article->oxarticles__oxid->value);
        if ($article->isBuyable()) {
            try {
                mo_viaebay__main::getInstance()->getInterface()->updateInventory($article);
            } catch (oxException $oEx) {
//                    $article->oxarticles__mo_viaebay__allow_export = new oxField(0);
//                    $article->save();
                $this->logger->error($oEx->getMessage());
                return false;
            }
        }

        if (!$oxVariantSelections = $article->getVariantSelections()) {
            return true;
        }
        foreach ($oxVariantSelections['rawselections'] as $key => $variantData) {
            //load variant
            $oxVariant = oxNew('oxarticle');
            if (!$oxVariant->load($key)) {
                continue;
            }

            if (!$oxVariant->oxarticles__mo_viaebay__via_id->value) {
                continue;
            }
            try {
                mo_viaebay__main::getInstance()->getInterface()->updateInventory($oxVariant);
            } catch (oxException $oEx) {
                /*
                 * After a fault: exclude parent article from sync
                 */
//                    $article->oxarticles__mo_viaebay__allow_export = new oxField(0);
//                    $article->save();
                $this->logger->error($oEx->getMessage());
                return false;
            }
        }
        return true;
    }

    public function updateLastMPSync($articleId)
    {
        $dateTime = new DateTime();
        $time = $dateTime->format('Y-m-d H:i:s');
        $db = oxdb::getDb();
        $sql = "UPDATE mo_viaebay__articles2via SET mo_viaebay__last_mpsync = " . $db->quote($time) . " WHERE OXARTID = " . $db->quote($articleId);
        $db->Execute($sql);
        return true;
    }

}
