<?php

/**
 * mo_viaebay__article_filter
 * 
 * VIAeBay Article Filter
 * 
 * @version   $Id: mo_viaebay__article_filter.php 217 2013-04-29 10:02:57Z $
 */

/**
 * VIAeBay Article Filter
 * 
 * @package   mo_viaebay
 * @extend oxAdminView 
 */
class mo_viaebay__article_filter extends oxAdminView
{

  /**
   * class template
   * 
   * @var string
   */
  protected $_sThisTemplate = 'mo_viaebay__article_filter.tpl';

  /**
   * display article filter and selected articles
   * 
   * @extend render
   * @return string
   */
  public function render()
  {
    parent::render();
    return $this->_sThisTemplate;
  }

  /**
   * save article filter and add list with selected articles to view
   * 
   * @extend save
   * @return void
   */
  public function save()
  {
    $viaMain            = mo_viaebay__main::getInstance();
    $viaConfig          = $viaMain->getViaebayConfig();
    $oxConfig           = $this->getConfig();
    $mo_viaebay__filter = $oxConfig->getRequestParameter("mo_viaebay__filter");

    $viaConfig['mo_viaebay__filter'] = $mo_viaebay__filter;
    $viaMain->setViaebayConfig($viaConfig);
    $viaMain->saveViaConfig();
    
    $viaMain->getHelper()->resetArticleSyncDates();
  }

  /**
   * get viaebay filter settings
   *
   * @return array 
   */
  public function mo_viaebay__getFilter()
  {
    $viaMain       = mo_viaebay__main::getInstance();
    $viaebayConfig = $viaMain->getViaebayConfig();
    return $viaebayConfig['mo_viaebay__filter'];
  }

  /**
   * get filtered article as simple list
   *
   * @return array 
   */
  public function mo_viaebay__getArticleList()
  {
    $oxArticleList = oxNew('oxarticlelist');
    return $oxArticleList->mo_viaebay__getSimpleList();
  }

}