<?php

/**
 * mo_viaebay__article_viaebay
 * 
 * Provides some via eBay-specific functionality
 * 
 * @version   $Id: mo_viaebay__article_viaebay.php 217 2013-04-29 10:02:57Z $
 */

/**
 * Provides some via eBay-specific functionality
 * 
 * @package   mo_viaebay
 * @extend oxAdminDetails 
 */
class mo_viaebay__article_viaebay extends oxAdminDetails
{

    /**
     * set tpl vars
     * 
     * @extend render
     * @return string 
     */
    public function render()
    {
        parent::render();

        return 'mo_viaebay__article_viaebay.tpl';
    }

    /**
     * Saves modified extended article parameters.
     *
     * @return mixed
     */
    public function save()
    {
        $id = $this->getEditObjectId();
        $params = $this->getConfig()->getRequestParameter("editval");
        
        //save longdesc according to module config
        $this->mo_viaebay__saveLongDescription($params['oxartextends__mo_viaebay__long_desc']);
        unset($params['oxartextends__mo_viaebay__long_desc']);
        
        $oArticle = oxNew("oxarticle");
        $oArticle->load($id);
        $oArticle->assign($params);
        $oArticle->save();
    }
    
    protected function mo_viaebay__saveLongDescription($longDesc)
    {
        $id = $this->getEditObjectId();
        $confparams = $this->getConfig()->getConfigParam('mo_viaebay__config');
        $tablename = $confparams['description_tablename'];
        $columnname = $confparams['description_coloumnname'];
        $articleId = $confparams['article_id'];
        
        $oxDb = oxDb::getDb();
        $sql = "UPDATE " . $tablename . "
                SET " . $columnname . " = " . $oxDb->quote($longDesc) . "
                WHERE " .
                $articleId . " = " . $oxDb->quote($id);
        $oxDb->Execute($sql);
    }
    
    /*
     * saving Allow export flag
     */
    public function saveAllowExportFlag($artid, $aParams)
    {
        $db = oxDb::getDb();
        $tablename = getViewName('mo_viaebay__articles2via ');
        
        $shopid = oxRegistry::getConfig()->getShopID();
        $selectsql = "SELECT oxid FROM " . $tablename . " WHERE oxartid = ". $db->quote($artid) . " AND oxshopid = " . $db->quote($shopid) . " ";
        $flag = $db->getOne($selectsql);
        //Insert new table entry to save allow_export 
        if ($flag == null){
            $oxid = oxUtilsObject::getInstance()->generateUID();
            $sql = " INSERT INTO " . $tablename . "(oxid, oxshopid, oxartid, mo_viaebay__allow_export ) "
                 ." VALUES ('" .$oxid. "','".$shopid."','".$artid."','".$aParams['oxarticles__mo_viaebay__allow_export']."');"; 
            
        }
        //Update allow_export flag
        else{
            $sql = "UPDATE " . $tablename . " SET mo_viaebay__allow_export = " . $aParams['oxarticles__mo_viaebay__allow_export'] . " WHERE oxartid = ". $db->quote($artid) . " ";
        }
        $db->Execute($sql);
    }

    /**
     * get edit object
     *
     * @return object 
     */
    public function mo_viaebay__getEditObject()
    {
        $oArticle = oxNew("oxarticle");
        $soxId = $this->getEditObjectId();

        if ($soxId != "-1" && isset($soxId)) {
            // load object
            $oArticle->load($soxId);
        }
        return $oArticle;
    }

    /**
     * get edit language
     *
     * @return integer 
     */
    public function mo_viaebay__getEditLanguage()
    {
        return $this->_iEditLang;
    }

}
