<?php

/**
 * mo_viaebay__config
 * 
 * Configure VIAebay interface
 * 
 * @version   $Id: mo_viaebay__config.php 217 2013-04-29 10:02:57Z $
 */

/**
 * Configure VIAebay interface
 * 
 * @package   mo_viaebay
 * @extend oxAdminView 
 */
class mo_viaebay__config extends oxAdminView
{

  /**
   * class template.
   * 
   * @var string
   */
  protected $_sThisTemplate = 'mo_viaebay__config.tpl';

  /**
   * render view
   * 
   * @extend render
   * @return string
   */
  public function render()
  {
    parent::render();

    return $this->_sThisTemplate;
  }

  /**
   * save config
   * 
   * @extend save
   * @return void
   */
  public function save()
  {
    $viaMain   = mo_viaebay__main::getInstance();
    $viaConfig = $viaMain->getViaebayConfig();
    $oxConfig  = $this->getConfig();

    $params    = $oxConfig->getRequestParameter('mo_viaebay__config');
    if (empty($params['description_tablename']))
    {
        $params['description_tablename'] = "oxartextends";
    }
        if (empty($params['description_coloumnname']))
    {
        $params['description_coloumnname'] = "MO_VIAEBAY__LONG_DESC";
    }
        if (empty($params['article_id']))
    {
        $params['article_id'] = "oxid";
    }
    
    $viaConfig = array_merge($viaConfig, $params);

    $viaMain->setViaebayConfig($viaConfig);
    $viaMain->saveViaConfig();
    
    $viaMain->getHelper()->resetArticleSyncDates();
  }

  /**
   * get viaebay config
   *
   * @return array 
   */
  public function mo_viaebay__getConfig()
  {
    $viaMain = mo_viaebay__main::getInstance();
    return $viaMain->getViaebayConfig();
  }

  /**
   * get viaebay tasks
   *
   * @return array 
   */
  public function mo_viaebay__getTasks()
  {
    return mo_viaebay__main::getInstance()->getTasks();
  }

  /**
   * get avaiable language names
   *
   * @return array 
   */
  public function mo_viaebay__getLanguages()
  {
    return oxRegistry::getLang()->getLanguageNames();
  }

  /**
   * check API connection with simple call
   *
   * @return array 
   */
  public function mo_viaebay__checkConnection()
  {
    //delete previously stored token from session
    oxRegistry::get('oxSession')->deleteVariable('mo_viaebay__session_cookie');
    
    try {
      mo_viaebay__main::getInstance()->getInterface()->getArticles(array(1));
    } catch (Exception $exc) {
      return false;
    }
    return true;
  }
}