<?php

/**
 * mo_viaebay__order_main
 * 
 * add via ebay functionality to order_main
 * 
 * @version   $Id: mo_viaebay__order_main.php 195 2012-12-21 15:17:12Z $
 */

/**
 * add via ebay functionality to order_main
 * 
 * @package   mo_viaebay
 * @extend order_main 
 */
class mo_viaebay__order_main extends mo_viaebay__order_main_parent
{

  /**
   * check for initial setting of payment-date and report payment to via
   * 
   * @extend save
   * @return mixed
   */
  public function save()
  {
    $id = $this->getEditObjectId();

    if (!($order = $this->mo_viaebay__checkOrder($id)))
    {
      return parent::save();
    }

    $result = parent::save();

    //reload order
    $order->load($id);

    //has valid paydate ?
    if ($order->oxorder__oxpaid->value == "0000-00-00 00:00:00")
    {
      return $result;
    }

    $order->mo_viaebay__reportPayment();

    return $result;
  }

  /**
   * Sends order.
   *
   * @extend sendorder
   * @return null
   */
  public function sendorder()
  {
    $id = $this->getEditObjectId();

    if (!($order = $this->mo_viaebay__checkOrder($id)))
    {
      return parent::sendorder();
    }

    $result = parent::sendorder();

    //reload order
    $order->load($id);

    $order->mo_viaebay__reportShipment();

    return $result;
  }

  /**
   * check order
   *
   * @param string $id
   * @return mixed 
   */
  protected function mo_viaebay__checkOrder($id)
  {
    $order = oxNew("oxorder");

    if ($id == "-1" || !$order->load($id))
    {
      return false;
    }

    if (!$order->mo_viaebay__isViaEbayOrder())
    {
      return false;
    }

    return $order;
  }

}