<?php

/**
 * mo_viaebay__reference_ajax
 * 
 * ajax list to cho0se categories and maunfacturers for export
 * 
 * @version   $Id: mo_viaebay__reference_ajax.php 213 2013-03-15 11:29:15Z $
 */

/**
 *  ajax list to choose categories and maunfacturers for export
 * 
 * @package   mo_viaebay
 * @extend ajaxListComponent 
 */
class mo_viaebay__reference_ajax extends ajaxListComponent
{

  /**
   * store reference settings
   *
   * @var array 
   */
  protected $mo_viaebay__reference__settings = null;

  /**
   * constructor 
   */
  public function __construct()
  {
    parent::__construct();
    $this->init();
  }

  /**
   * init ajax list componenet
   *
   * extend init
   * @param array $aColumns 
   */
  public function init($aColumns = array())
  {
    parent::init($aColumns);

    $settings = mo_viaebay__main::getInstance()->getViaebayReference();
    $type     = oxRegistry::getConfig()->getRequestParameter('mo_viaebay__reference__type');

    if (isset($settings[$type]))
    {
      $this->mo_viaebay__reference__settings = $settings[$type];
      $this->_aColumns = $this->mo_viaebay__reference__getColumnsParam();
    }
  }

  /**
   * get coloumns parameter
   *
   * @return array 
   */
  protected function mo_viaebay__reference__getColumnsParam()
  {
    $viewNameTable    = $this->_getViewName($this->mo_viaebay__reference__settings['table']);
    $viewNameRefTable = $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']);

    return array(
        'container1' => array(// field , table,  visible, multilanguage, ident
            array($this->mo_viaebay__reference__settings['display_column'], $viewNameTable, 1, 0, 0),
            array('oxid', $viewNameTable, 0, 0, 0),
            array('oxid', $viewNameTable, 0, 0, 1),
        ),
        'container2' => array(
            array($this->mo_viaebay__reference__settings['display_column'], $viewNameTable, 1, 0, 0),
            array('oxid', $viewNameTable, 0, 0, 0),
            array('oxid', $viewNameRefTable, 0, 0, 1),
        )
    );
  }

  /**
   * Returns SQL query for data to fetch
   *
   * @return string
   */
  protected function _getQuery()
  {
    $oxConfig = oxRegistry::getConfig();
    $db       = oxDb::getDb();

    //$settings = $oxConfig->getConfigParam('mo_viaebay__reference');
    $settings = mo_viaebay__main::getInstance()->getViaebayReference();
    $type     = oxRegistry::getConfig()->getRequestParameter('mo_viaebay__reference__type');

    if (isset($settings[$type]))
    {
      $this->mo_viaebay__reference__settings = $settings[$type];
      $this->_aColumns = $this->mo_viaebay__reference__getColumnsParam();
    }

    if (empty($this->mo_viaebay__reference__settings))
    {
      return parent::_getQuery();
    }

    // active AJAX component
    $sGroupTable = $this->_getViewName($this->mo_viaebay__reference__settings['table']);
    $refTable    = $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']);

    $objectId    = oxRegistry::getConfig()->getRequestParameter('oxid');
    $synchOxidId = oxRegistry::getConfig()->getRequestParameter('synchoxid'); //if set, left container
    // category selected or not ?
    if (!$objectId)
    {
      $sql = "  FROM $sGroupTable 
                  WHERE 1 ";
    }
    else
    {
      $sql = "  FROM " . $refTable . " 
                  INNER JOIN $sGroupTable 
                  ON " . $refTable . "." . $this->mo_viaebay__reference__settings['ref_field_2'] . " = $sGroupTable.oxid ";

      $sql .= " WHERE " .
              $refTable . ". " . $this->mo_viaebay__reference__settings['ref_field_1'] . " = '$objectId' ";
    }

    if ($synchOxidId && $synchOxidId != $objectId)
    {
      $sql .= ' AND ' . $sGroupTable . '.oxid NOT IN 
                ( SELECT ' . $sGroupTable . '.oxid 
                  FROM ' . $refTable . ' 
                  INNER JOIN ' . $sGroupTable . ' 
                  ON ' . $refTable . '.' . $this->mo_viaebay__reference__settings['ref_field_2'] . '=' . $sGroupTable . '.oxid ';

      $sql .= " WHERE " .
              $refTable . "." . $this->mo_viaebay__reference__settings['ref_field_1'] . " = '$synchOxidId' ";

      if ($this->mo_viaebay__reference__settings['ref_table_has_shop_id'])
      {
        $sql .= " AND " . $refTable . ".OXSHOPID = " . $db->quote($oxConfig->getShopID()) . " ";
      }

      $sql .= " ) ";
    }

    return $sql;
  }

  /**
   * Remove reference
   *
   * @return null
   */
  public function mo_viaebay__reference__remove()
  {
    $settings = mo_viaebay__main::getInstance()->getViaebayReference();
    $type     = oxRegistry::getConfig()->getRequestParameter('mo_viaebay__reference__type');

    if (isset($settings[$type]))
    {
      $this->mo_viaebay__reference__settings = $settings[$type];
      $this->_aColumns = $this->mo_viaebay__reference__getColumnsParam();
    }

    $refTable = $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']);

    $aRemoveGroups = oxRegistry::getConfig()->getRequestParameter('_2');

    if (oxRegistry::getConfig()->getRequestParameter('all'))
    {

      $sql = $this->_addFilter("DELETE " . $refTable . ".* " . $this->_getQuery());
      oxDb::getDb()->Execute($sql);
    }
    elseif ($aRemoveGroups && is_array($aRemoveGroups))
    {
      $sql = " DELETE FROM " . $refTable . " 
              WHERE " . $refTable . ".oxid IN (" . implode(", ", oxDb::getInstance()->quoteArray($aRemoveGroups)) . ") ";
      oxDb::getDb()->Execute($sql);
    }
  }

  /**
   * add reference
   *
   * @return null
   */
  public function mo_viaebay__reference__add()
  {
    $viewNameTable = $this->_getViewName($this->mo_viaebay__reference__settings['table']);
    $soxId         = 'mo_viaebay_' . oxRegistry::getConfig()->getShopID();
    $addItems      = oxRegistry::getConfig()->getRequestParameter('_2');


    if (oxRegistry::getConfig()->getRequestParameter('all'))
    {
      $addItems = $this->_getAll($this->_addFilter("SELECT $viewNameTable.oxid " . $this->_getQuery()));
    }
    if ($soxId && $soxId != "-1" && is_array($addItems))
    {
      foreach ($addItems as $addItem)
      {
        $this->mo_viaebay__reference__saveReference($soxId, $addItem);
      }
    }
  }

  /**
   * check if reference exists
   *
   * @param string $objectId
   * @param string $referenceId
   * @return mixed 
   */
  protected function mo_viaebay__reference__referenceExists($objectId, $referenceId)
  {
    $oxConfig = oxRegistry::getConfig();
    $db       = oxDb::getDb();

    $sql = "SELECT 1 
            FROM " . $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']) . "
            WHERE " . $this->mo_viaebay__reference__settings['ref_field_1'] . " = " . $db->quote($objectId) . " 
            AND " . $this->mo_viaebay__reference__settings['ref_field_2'] . " = " . $db->quote($referenceId);

    if ($this->mo_viaebay__reference__settings['ref_table_has_shop_id'])
    {
      $sql .= " AND OXSHOPID = " . $db->quote($oxConfig->getShopID()) . " ";
    }

    return $db->getOne($sql);
  }

  /**
   * save reference
   *
   * @param string $objectId
   * @param string $referenceId
   * @return mixed 
   */
  protected function mo_viaebay__reference__saveReference($objectId, $referenceId)
  {
    $oxConfig = oxRegistry::getConfig();

    if ($this->mo_viaebay__reference__referenceExists($objectId, $referenceId))
    {
      return;
    }

    $db  = oxDb::getDb();
    $sql = "INSERT INTO " . $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']) . "
            SET 
            OXID = " . $db->quote(oxUtilsObject::getInstance()->generateUId()) . ", " .
            $this->mo_viaebay__reference__settings['ref_field_1'] . " = " . $db->quote($objectId) . ", " .
            $this->mo_viaebay__reference__settings['ref_field_2'] . " = " . $db->quote($referenceId);

    if ($this->mo_viaebay__reference__settings['ref_table_has_shop_id'])
    {
      $shopId = $oxConfig->getShopID();
      $sql .= ", OXSHOPID = " . $db->quote($shopId) . " ";
//      $sql .= ", OXSHOPINCL = " . $db->quote(oxRegistry::getUtils()->getShopBit($shopId)) . " "; // < 4.6
      $sql .= ", OXSHOPINCL = " . $db->quote(oxShopMetaData::getInstance()->getShopBit($shopId)) . " "; // >= 4.6
    }

    //get sorting position
    if ($pos = $this->mo_viaebay__reference__getNextSortingPosition($objectId))
    {
      $sql .= ", " . $this->mo_viaebay__reference__settings['sort_column'] . " = " . $db->quote($pos) . " ";
    }

    $db->Execute($sql);
  }

  /**
   * get next sorting position
   *
   * @param string $objectId
   * @return mixed 
   */
  protected function mo_viaebay__reference__getNextSortingPosition($objectId)
  {
    if (empty($this->mo_viaebay__reference__settings['sort_column']))
    {
      return false;
    }

    $refTable = $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']);
    $oxConfig = oxRegistry::getConfig();
    $db       = oxDb::getDb();

    $sql = "SELECT MAX(" . $this->mo_viaebay__reference__settings['sort_column'] . ")
            FROM " . $refTable . "
            WHERE " . $this->mo_viaebay__reference__settings['ref_field_1'] . " = " . $db->quote($objectId);

    if ($this->mo_viaebay__reference__settings['ref_table_has_shop_id'])
    {
      $sql .= " AND OXSHOPID = " . $db->quote($oxConfig->getShopID()) . " ";
    }

    return ($db->getOne($sql) + 1);
  }

  /**
   * Returns SQL query addon for sorting
   *
   * @return string
   */
  protected function _getSorting()
  {
    if (empty($this->mo_viaebay__reference__settings))
    {
      return parent::_getSorting();
    }

    if (oxRegistry::getConfig()->getRequestParameter('oxid') && !oxRegistry::getConfig()->getRequestParameter('synchoxid'))
    {
      return ' ORDER BY ' . $this->_getViewName($this->mo_viaebay__reference__settings['ref_table']) . '.' . $this->mo_viaebay__reference__settings['sort_column'] . ' ';
    }
  }

  /**
   * Return the view name of the given table if a view exists, otherwise the table name itself
   *
   * @BC < 4.5
   * @param string $sTable table name
   * @return string
   */
  protected function _getViewName($sTable)
  {
    return getViewName($sTable, oxRegistry::getConfig()->getRequestParameter('editlanguage'));
  }

}