<?php

/**
 * Provides parameters for OXID module handling.
 * 
 * @version   $Id: metadata.php 223 2013-06-21 14:23:53Z $  
 */

/**
 * Metadata version
 */
$sMetadataVersion = '1.1';

/**
 * Module information
 */
$aModule = array(
    'id'          => 'mo_viaebay',
    'title'       => 'VIA ebay',
    'description' => array(
        'de' => '<p>Das VIA-eBay Modul ermöglicht das Einstellen von Produkten aus Ihrem OXID eShop auf eBay. '
        . 'Dabei werden aus der Produktdatenbank die Produktinformationen an VIA-eBay übergeben. VIA-eBay wandelt '
        . 'diese in eBay-konforme Daten um, die dann bei eBay, nach Ihren Vorgaben, als Produkte eingestellt werden.</p>'
        . '<p>Das aktuelle Benutzerhandbuch finden Sie '
        . '<a href="http://projects.mediaopt.de/projects/viaebay/wiki/Handbuch" target="_blank">'
        . '<strong>hier</strong></a>.</p>',
    ),
    'lang'        => 'de',
    'thumbnail'   => 'logo.png',
    'version'     => '1.3.10 revision 154',
    'author'      => 'Mediaopt GmbH',
    'url'         => 'http://www.mediaopt.de',
    'email'       => 'oxid@mediaopt.de',
    'extend'      => array(
        'oxbase'         => 'mo_viaebay/models/mo_viaebay__oxbase',
        'oxcategory'     => 'mo_viaebay/models/mo_viaebay__oxcategory',
        'oxcategorylist' => 'mo_viaebay/models/mo_viaebay__oxcategorylist',
        'oxarticlelist'  => 'mo_viaebay/models/mo_viaebay__oxarticlelist',
        'oxarticle'      => 'mo_viaebay/models/mo_viaebay__oxarticle',
        'oxorder'        => 'mo_viaebay/models/mo_viaebay__oxorder',
        'oxorderarticle' => 'mo_viaebay/models/mo_viaebay__oxorderarticle',
        'oxbasket'       => 'mo_viaebay/models/mo_viaebay__oxbasket',
        'oxbasketitem'   => 'mo_viaebay/models/mo_viaebay__oxbasketitem',
        'order_main'     => 'mo_viaebay/controllers/admin/mo_viaebay__order_main',
        'order_overview' => 'mo_viaebay/controllers/admin/mo_viaebay__order_overview',
        'oxuser'         => 'mo_viaebay/models/mo_viaebay__oxuser',
    ),
    'files'          => array(
        'mo_viaebay__article_filter'          => 'mo_viaebay/controllers/admin/mo_viaebay__article_filter.php',
        'mo_viaebay__article_viaebay'         => 'mo_viaebay/controllers/admin/mo_viaebay__article_viaebay.php',
        'mo_viaebay__category_viaebay'        => 'mo_viaebay/controllers/admin/mo_viaebay__category_viaebay.php',
        'mo_viaebay__config'                  => 'mo_viaebay/controllers/admin/mo_viaebay__config.php',
        'mo_viaebay__order_viaebay'           => 'mo_viaebay/controllers/admin/mo_viaebay__order_viaebay.php',
        'mo_viaebay__reference'               => 'mo_viaebay/controllers/admin/mo_viaebay__reference.php',
        'mo_viaebay__reference_ajax'          => 'mo_viaebay/controllers/admin/mo_viaebay__reference_ajax.php',
        'mo_viaebay__status'                  => 'mo_viaebay/controllers/admin/mo_viaebay__status.php',
        'mo_viaebay__sync_admin'              => 'mo_viaebay/controllers/admin/mo_viaebay__sync_admin.php',
        'mo_viaebay__client'                  => 'mo_viaebay/classes/mo_viaebay__client.php',
        'mo_viaebay__feedback_handler'        => 'mo_viaebay/classes/mo_viaebay__feedback_handler.php',
        'mo_viaebay__interface'               => 'mo_viaebay/classes/mo_viaebay__interface.php',
        'mo_viaebay__logger'                  => 'mo_viaebay/classes/mo_viaebay__logger.php',
        'mo_viaebay__main'                    => 'mo_viaebay/classes/mo_viaebay__main.php',
        'mo_viaebay__param_builder'           => 'mo_viaebay/classes/mo_viaebay__param_builder.php',
        'mo_viaebay__helper'                  => 'mo_viaebay/classes/mo_viaebay__helper.php',
        'mo_viaebay__cron_control'            => 'mo_viaebay/classes/mo_viaebay__cron_control.php',
        'mo_viaebay__task_manager'            => 'mo_viaebay/classes/mo_viaebay__task_manager.php',
        'mo_viaebay__feed'                    => 'mo_viaebay/classes/feeds/mo_viaebay__feed.php',
        'mo_viaebay__feed_categories'         => 'mo_viaebay/classes/feeds/mo_viaebay__feed_categories.php',
        'mo_viaebay__feed_articles'           => 'mo_viaebay/classes/feeds/mo_viaebay__feed_articles.php',
        'mo_viaebay__feed_article_ids'        => 'mo_viaebay/classes/feeds/mo_viaebay__feed_article_ids.php',
        'mo_viaebay__feed_orders'             => 'mo_viaebay/classes/feeds/mo_viaebay__feed_orders.php',
        'mo_viaebay__feed_inventory'          => 'mo_viaebay/classes/feeds/mo_viaebay__feed_inventory.php',
        'mo_viaebay__sync_manager'            => 'mo_viaebay/classes/sync_managers/mo_viaebay__sync_manager.php',
        'mo_viaebay__sync_manager_categories' => 'mo_viaebay/classes/sync_managers/mo_viaebay__sync_manager_categories.php',
        'mo_viaebay__sync_manager_articles'   => 'mo_viaebay/classes/sync_managers/mo_viaebay__sync_manager_articles.php',
        'mo_viaebay__sync_manager_orders'     => 'mo_viaebay/classes/sync_managers/mo_viaebay__sync_manager_orders.php',
        'mo_viaebay__sync_manager_inventory'  => 'mo_viaebay/classes/sync_managers/mo_viaebay__sync_manager_inventory.php',
        'mo_viaebay__events' => 'mo_viaebay/classes/mo_viaebay__events.php',
        'mo_viaebay__attribute_viaebay' => 'mo_viaebay/controllers/admin/mo_viaebay__attribute_viaebay.php',
        'mo_viaebay__payment_viaebay' => 'mo_viaebay/controllers/admin/mo_viaebay__payment_viaebay.php',
        'mo_viaebay__shipping_viaebay' => 'mo_viaebay/controllers/admin/mo_viaebay__shipping_viaebay.php',
        'mo_viaebay__articles2via' => 'mo_viaebay/models/mo_viaebay__articles2via.php',
    ),
        'events' => array(
             'onActivate' => 'mo_viaebay__events::onActivate',   
    ),
    'templates' => array(
        'mo_viaebay__article_filter.tpl'  => 'mo_viaebay/views/admin/tpl/mo_viaebay__article_filter.tpl',
        'mo_viaebay__article_viaebay.tpl' => 'mo_viaebay/views/admin/tpl/mo_viaebay__article_viaebay.tpl',
        'mo_viaebay__category_viaebay.tpl' => 'mo_viaebay/views/admin/tpl/mo_viaebay__category_viaebay.tpl',
        'mo_viaebay__config.tpl'          => 'mo_viaebay/views/admin/tpl/mo_viaebay__config.tpl',
        'mo_viaebay__order_viaebay.tpl'   => 'mo_viaebay/views/admin/tpl/mo_viaebay__order_viaebay.tpl',
        'mo_viaebay__status.tpl'          => 'mo_viaebay/views/admin/tpl/mo_viaebay__status.tpl',
        'mo_viaebay__sync_admin.tpl'      => 'mo_viaebay/views/admin/tpl/mo_viaebay__sync_admin.tpl',
        'mo_viaebay__reference.tpl'       => 'mo_viaebay/views/admin/tpl/popups/mo_viaebay__reference.tpl',
        'mo_viaebay__attribute_viaebay.tpl' => 'mo_viaebay/views/admin/tpl/mo_viaebay__attribute_viaebay.tpl',
        'mo_viaebay__payment_viaebay.tpl' => 'mo_viaebay/views/admin/tpl/mo_viaebay__payment_viaebay.tpl',
         'mo_viaebay__shipping_viaebay.tpl' => 'mo_viaebay/views/admin/tpl/mo_viaebay__shipping_viaebay.tpl',
    ),
);