<?php

/**
 * mo_viaebay__oxcategory
 * 
 * add via ebay functionality to oxcategory
 * 
 * @version   $Id: mo_viaebay__oxcategory.php 139 2012-12-10 16:51:05Z $
 */

/**
 * add via ebay functionality to oxcategory
 * 
 * @package   mo_viaebay
 * @extend oxcategory 
 */
class mo_viaebay__oxcategory extends mo_viaebay__oxcategory_parent
{

    /**
     * check if category has a parent category
     *
     * @return boolean 
     */
    public function mo_viaebay__hasParentCategory()
    {
        return (bool) $this->getParentCategory();
    }

    /**
     * allow derived update in via script context
     */
    public function allowDerivedUpdate()
    {
        if (!defined('MO_VIAEBAY__IS_SCRIPT_CONTEXT')) {
            return parent::allowDerivedUpdate();
        }
        return true;
    }

    /**
     * load categories for shop in via-context
     */
    public function load($sOXID)
    {
        if (!defined('MO_VIAEBAY__IS_SCRIPT_CONTEXT')) {
            return parent::load($sOXID);
        }
        $aData = $this->mo_viaebay__categories2via($sOXID);
        if ($aData) {
            $this->assign($aData);
            return true;
        }
        return false;
    }

    public function mo_viaebay__categories2via($sOXID)
    {
        $dummy = oxNew('oxcategory');
        $categoriesTable = $dummy->getViewName();
        //?
        $shopID = $this->getConfig()->getShopId();
        $oDb = oxDb::getDb();
        $catRefTable = getViewName('mo_viaebay__category2via');
        $sql = "SELECT A.*, U.OXID AS category2viaoxid, U.OXSHOPID AS category2viashopid, U.MO_VIAEBAY__VIA_ID, U.MO_VIAEBAY__VIA_PARENT_ID, U.MO_VIAEBAY__LAST_SYNC  
        FROM " . $categoriesTable . " AS A
        INNER JOIN " . $catRefTable . " AS U
        ON  A.OXID = U.OXCATNID 
        WHERE (A.OXID = " . $oDb->quote($sOXID)
                . ") AND (U.OXSHOPID =" . $oDb->quote($shopID) . ")";
        $aData = oxDb::getDb(oxDb::FETCH_MODE_ASSOC)->getRow($sql);
        return $aData;
    }

    /**
     * additional saving of category2via-Data
     * @return bool
     */
    public function save()
    {
        if (!defined('MO_VIAEBAY__IS_SCRIPT_CONTEXT')) {
            return parent::save();
        }
        /**
         * saving category + saving category2via-Data
         */
        $this->mo_viaebay__savecategory2via();
        return true;
    }

    /**
     * Saving Data in DB-Table mo_viaebay__category2via
     */
    public function mo_viaebay__savecategory2via()
    {
        $oxConfig = $this->getConfig();
        $ShopId = $oxConfig->getShopID();
        $id = $this->mo_viaebay__getCategory2viaField("oxid");
        $cat2via = oxNew('oxBase');
        $cat2via->init('mo_viaebay__category2via');
        $cat2via->load($id);
        $viaId = $this->oxcategories__mo_viaebay__via_id;
        $parentViaId = $this->oxcategories__mo_viaebay__via_parent_id;
        $lastViaSync = $this->oxcategories__mo_viaebay__last_sync;
        $catNid = $this->getId();
        $cat2via->mo_viaebay__category2via__oxcatnid = new oxField($catNid, oxField::T_RAW);
        $cat2via->mo_viaebay__category2via__oxshopid = new oxField($ShopId, oxField::T_RAW);
        if (!empty($viaId->value)){
        $cat2via->mo_viaebay__category2via__mo_viaebay__via_id = new oxField($viaId, oxField::T_RAW);
        }
        If (!empty($parentViaId->value)){
        $cat2via->mo_viaebay__category2via__mo_viaebay__via_parent_id = new oxField($parentViaId, oxField::T_RAW);
        }
        If (!empty($lastViaSync->value)){
        $cat2via->mo_viaebay__category2via__mo_viaebay__last_sync = new oxField($lastViaSync, oxField::T_RAW);
        }
        $cat2via->save();
    }

    public function mo_viaebay__getCategory2viaField($field)
    {
        $db = oxDb::getDb();
        $viewName = getViewName('mo_viaebay__category2via');
        $oxConfig = $this->getConfig();
        $ShopId = $oxConfig->getShopID();
        $oxcatnid = $this->getId();
        $result = $db->getOne("select " . $field . " from {$viewName} where ( oxcatnid = "
                . $db->quote($oxcatnid) . ") AND (oxshopid = " . $db->quote($ShopId) . ")");
        if ($result === false) {
            return null;
        }
        return $result;
    }

}
