<?php

/**
 * mo_viaebay__oxcategorylist
 * 
 * add via ebay functionality to oxcategorylist
 * 
 * @version   $Id: mo_viaebay__oxcategorylist.php 139 2012-12-10 16:51:05Z $
 */

/**
 * add via ebay functionality to oxcategorylist
 * 
 * @package   mo_viaebay
 * @extend oxcategorylist
 */
class mo_viaebay__oxcategorylist extends mo_viaebay__oxcategorylist_parent
{

  /**
   * get list of all categories
   *
   * @return oxcategorylist 
   */
  public function mo_viaebay__getList()
  {
    $dummy = oxNew('oxcategory');
//$dummy->getSelectFields()
    $sql = "SELECT *
            FROM " . $dummy->getViewName() . "
            WHERE
            " . $dummy->getSqlActiveSnippet() . "
            ORDER BY OXROOTID ASC, OXLEFT ASC";


    $this->selectString($sql);
    $this->mo_viaebay__cleanupTree();

    return $this;
  }

  /**
   * sort out any leafs of inactive parent-categories 
   */
  protected function mo_viaebay__cleanupTree()
  {
    $tree = $this->getArray();
    foreach ($tree as $key => $category)
    {
      $this->mo_viaebay__handleArray($tree, $key, $category);
    }

    $this->assign($tree);
  }

  /**
   * sort out any leafs of inactive parent-categories 
   *
   * @param array $tree
   * @param string $key
   * @param oxCategory $category
   * @return mixed 
   */
  protected function mo_viaebay__handleArray($tree, $key, $category)
  {
    //check if parent is set
    if (!$category->mo_viaebay__hasParentCategory())
    {
      return;
    }

    if (!isset($tree[$category->oxcategories__oxparentid->value]))
    {
      unset($tree[$key]);
    }
  }

}