<?php

/**
 * mo_viaebay__sync_articles
 * 
 * script that syncs articles with via api
 * 
 * @package   mo_viaebay
 * @version   $Id: mo_viaebay__sync_articles.php 212 2013-03-15 11:19:03Z $ 
 */
include_once dirname(__FILE__) . '/bootstrap.php';
$logger = mo_viaebay__main::getInstance()->getLogger();
$logger->info('Sync-Manager: executing task sync_inventory');
$report = array(
    'success' => array(),
    'failed' => array(),
);

try {
    // get viaConfig
    $viaMain            = mo_viaebay__main::getInstance();
    $viaConfig          = $viaMain->getViaebayConfig();
    if (!$articleSyncNumber = $viaConfig['tasks']['sync_inventory']['syncNumber']){
        $articleSyncNumber = 1000;
    }
    //get local list
    $oxArticleList = oxNew('oxarticlelist');
    $list = $oxArticleList->mo_viaebay__getSimpleList(true);
    $syncManager = mo_viaebay__main::getInstance()->getSyncManager('inventory', array());
    $oxArticle = oxNew('oxarticle');
    $count = 0;
    foreach ($list as $key => $data) {
        $currentArticle = clone($oxArticle);
        $result = $currentArticle->load($key);
        $msg = $currentArticle->oxarticles__oxtitle->value . ' (' . $currentArticle->oxarticles__oxartnum->value . ')';
        $count++;
        if ($syncManager->syncObject($currentArticle)) {
            $report['success'][] = $msg;
        } else {
            $report['failed'][] = $msg;
        }
        $currentArticle->mo_viaebay__flush();
        if ($count >= $articleSyncNumber){
            break;
        }
    }

    mo_viaebay__main::getInstance()->getTaskManager()->markTaskAsFinished('sync_inventory');
} catch (oxException $oEx) {
    $logger->error($oEx->getMessage());
}

$logger->info('Sync-Manager: finished task sync_inventory');

foreach ($report['success'] as $success) {
    echo '<pre>OK: ' . $success . '</pre>';
}

foreach ($report['failed'] as $failed) {
    echo '<pre>Failed: ' . $failed . '</pre>';
}
echo '<pre>----------------------------------------------------</pre>';
echo '<pre>Erfolgreich: ' . count($report['success']) . '</pre>';
echo '<pre>Fehlgeschlagen: ' . count($report['failed']) . '</pre>';
